/**************************************/
/*   Z-Buffer Drawing Program         */
/*                                    */
/*   Victor L. Miller    Mar 1998     */
/*                                    */
/*   Use Z-Buffer and Frame-Buffer    */
/*   For Visible Surface Determination*/
/*   Use Surface Normals and Dot      */
/*   Product With Light Source Vector */
/*   To Determine Illumination On     */
/*   Each Face                        */
/**************************************/
/**************************************/
/*    3-D OBJECT DRAWING PROGRAM      */
/*    V. MILLER  March 1998           */
/*    3-D PROJECTION DRAWING PROGRAM  */
/*                                    */
/*    DEPTH SORT FOR HIDDEN POLYGONS  */
/*                                    */
/*    READS *._3D FILES WHICH ARE     */
/*    ASCII VERSIONS OF BINARY *.3DS  */
/*    FILES                           */
/*                                    */
/*    *.3DS FILES ARE CONVERTED TO    */
/*    ASCII *._3D FILES WITH PROGRAM  */
/*    3DSRDR.C FROM FINLAND (x2ftp)   */
/**************************************/
/**************************************/
/*    USE SETUP OF CUSTOM PALETTE     */
/*    TO PREPARE FOR SHADING GRAPHICS */
/*                                    */
/*    with Super VGA SVGA MODES       */
/*      1024 x 768 x 256 COLOR MODE   */
/*       800 x 600 x 256 COLOR MODE   */
/*       640 x 480 x 256 COLOR MODE   */
/*       640 x 400 x 256 COLOR MODE   */
/*       320 x 200 x 256 COLOR MODE   */
/*                                    */
/**************************************/
/**************************************/
/*    Use Cross Product of Polygon    */
/*    Edges To Determine Surface      */
/*    Normals                         */
/*                                    */
/*    Use Dot Product of Surface      */
/*    Normal With Light Source        */
/*    Unit Direction Vector To        */
/*    Determine Illumination Level    */
/*    On Each Face                    */
/*                                    */
/**************************************/
#include <dos.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <graphics.h>
#include <alloc.h>
#include <bios.h>
#include <process.h>
#include "svgautil.h"
#include "svga256.h"
int graphics_driver,graphics_mode;
int ixpt,iypt,ipen,i,ipl,iv,ivert,j,k,p,istyle,ixtxt,iytxt;
int nvert,nplate,npvert,nfaces,aa,bb,cc,icolor,itemp;
int inumplate,inumvertice,istartplate,index,npoints,npplate;
float zdepth;
int face_color[600];
float face_normal[3][600];
float scicon,pilotx,piloty,pilotz,vertex[3][600],faces[3][600];
float x,y,z,cgx,cgy,cgz;
double xx,yy,zz;
float xa=0.,ya=0.,za=0.;
float xmax,xmin,ymax,ymin,zmax,zmin,xspread,yspread,zspread,spread;
float xmiddle,ymiddle,zmiddle;
float r1=0.,r2=0.,r3=0.;
float sr1=0., sr2=0., sr3=0.;
float cr1=0., cr2=0., cr3=0.;
float rd1=0,rd2=0,rd3=0;
int hertz=100, duration=10000;
float movex=0.,movey=0.,movez=300.;
float sx=0.,sy=0.;
float sxavg,syavg,sxstart,systart,sxseed,syseed;
float sxa=0., sya=0., sxb=0., syb=0., szb;
float pi=3.141592, d=1200.,a;
float angle,range,radius,xcenter,ycenter,xpt,ypt,xout,yout,xin,yin;
int   iloop, iloop2, iswapflag=1, ipoint, iface;
int   isection, j_level, icase, ibypass, jj;
int iplate_a,iplate_b,iplate_c;
int zin,zout,c;
char string[80],string_value[4],str_pointer;
int istring_start,ivalue,ivert,ix,iy,iz;
float tempiplate, tempzdepth, mag, dot__product, cos_theta;
int ispan, istep, ispanstep, idrawflag;
float dx1, dx2, dz1, dz2, dzstep, zlow, zhgh, zdepth, zlow_hold, zhgh_hold;
int    xlow, xhgh, xlow_hold, xhgh_hold, yhgh_hold;

typedef struct { int    x, y, z ; } point3d;
typedef struct { float fx,fy,fz ; } float3d;
point3d triangle[3], point3d_one, point3d_two, point3d_three, point3d_temp;
float3d tri_face[3], edge_1,edge_2,normal,current_face_normal,light_source_spot,
		     light_source_normal,
		     float3d_one, float3d_two, float3d_three, float3d_temp;

int frame_buffer[640][10];          /* Frame Buffer For Pixel Color Values */
float   z_buffer[640][10];          /*     Z-Buffer For Pixel Depth Values */

int t1=0,t2=0,p1=0;
char dummy,buffer[80];

typedef struct{                     /* rgbvalue for creating palette */
   unsigned char red, green, blue;
} rgbvalue;

typedef rgbvalue VGApalette[256];   /* 256 colors rgbvalue storage */ /*VGApalette[] is a typedef */
VGApalette pal;                     /* pal is the actual storage array which is of type VGApalette*/

void keyboard_input(void);
int huge DetectVGA256()
{
  int Vid;

//  printf("Which video mode would you like to use? \n");
//  printf("  0) 320x200x256\n");
//  printf("  1) 640x400x256\n");
//  printf("  2) 640x480x256\n");
//  printf("  3) 800x600x256\n");
//  printf("  4) 1024x768x256\n");
//  printf("  5) 640x480x256\n");
//  printf("  6) 1280x1024x256\n");
//  printf("\n> ");
/*scanf("%d",&Vid);          */
  Vid=2;                      /* Force mode 2 =   640 x 480 x 256 colors */
  return Vid;        }

/* palette handling */
void VGAsetpalette(VGApalette p)
  {
     union REGS inregs, outregs;
     struct SREGS segregs;

     inregs.x.ax = 0x1012;
     inregs.x.bx = 0;
     inregs.x.cx = 256;
     segregs.es = FP_SEG(p);
     inregs.x.dx = FP_OFF(p);

   /* DOS interupt rountine 16 is for video functions */
      int86x(0x10, &inregs, &outregs, &segregs);
  }

FILE *fp;
void keyboard(void);
void keyboard_input(void);
void calc_3d(void);
void rotation(void);
void vic_sort(void);
float maximum(float x,float y);
float minimum(float x,float y);
void calc_normal(void);
void dot_product(void);
void lambert(void);
void display_palette(void);
void display_lighting(void);
void polyfill_vic(void);

main()
{
	fp=fopen("engine3d.new","r");         /* open icon file */
/*      printf("Opened File \n");   */
	ipoint=0;
	iface=0;
	while(feof(fp) == 0) {              /* read until End-Of-File is reached */
/*      fread(&string,80,1,fp);  */         /* read line as string */
	fgets(string,80,fp);                /* read line from file as string */
/*      for(i=1;i<=80;i++) {
	printf("%c",string[i-1]); }  */

	istring_start=0;
	str_pointer=strstr(string,"Vertices:");
	if(str_pointer!=NULL) {
/*      printf("Vertices: found at position %i \n",str_pointer);
	for(i=1;i<=80;i++) {printf("%c",string[i-1]);}
	keyboard();                                      */
	sscanf(string,"%*s%d",&nvert);
/*      printf("The number of verticies assigned is %i \n",nvert); */
	str_pointer=NULL;
/*      keyboard();        */                         }

	str_pointer=strstr(string,"X:");
	if(str_pointer!=NULL) {
/*      printf("Found X: Y: Z: Data \n");
	for(i=1;i<=80;i++) {printf("%c",string[i-1]);}    */
/*      sscanf(string,"%*s%f, %*s%f, %*s%f\n",&x,&y,&z);  */
	sscanf(string,"              X: %f, Y: %f, Z: %f",&x,&y,&z);
	vertex[0][ipoint]=x;
	vertex[1][ipoint]=y;
	vertex[2][ipoint]=z;
	ipoint=ipoint+1;

	xmax=maximum(xmax,x);                  /* find x,y,z mins and maxs for scaling */
	xmin=minimum(xmin,x);
	ymax=maximum(ymax,y);
	ymin=minimum(ymin,y);
	zmax=maximum(zmax,z);
	zmin=minimum(zmin,z);

/*      for(j=1;j<=ivert;j++) {
	fscanf(fp,"%*s%d%*s%d%*s%d \n",&x,&y,&z);   */
/*      printf("Assigned X: %f Y: %f Z: %f \n",x,y,z); */
	str_pointer=NULL;
	/* keyboard(); */   }

	str_pointer=strstr(string,"Faces:");
	if(str_pointer!=NULL) {
/*      printf("Found Face Number \n");        */
	sscanf(string,"%*s%d",&nfaces);
/*      printf("The number of faces is %i \n",nfaces);   */
	str_pointer=NULL;
/*      keyboard();        */    }

	str_pointer=strstr(string,"A:");
	if(str_pointer!=NULL) {
/*      printf("Found Face Data \n");      */
	sscanf(string,"      A: %i, B: %i, C: %i,%i",&aa,&bb,&cc,&icolor);
	faces[0][iface]=aa;
	faces[1][iface]=bb;
	faces[2][iface]=cc;
	face_color[iface]=icolor;
	iface=iface+1;

	printf("Assigned Face A: %i B: %i C: %i D: %i \n",aa,bb,cc,icolor);
	str_pointer=NULL;
	/* keyboard(); */           }
				  }               /* End-Of-File */
/*      printf("Finished Reading Object File");
	keyboard();                             */
	xspread=xmax - xmin;                      /* Find biggest spread in x,y,z */
	yspread=ymax - ymin;
	zspread=zmax - zmin;
	spread=maximum(xspread,yspread);
	spread=maximum(spread,zspread);
	cgx=(xmax+xmin)/2.;
	cgy=(ymax+ymin)/2.;
	cgz=(zmax+zmin)/2.;
	if(xmin<0) xmin=xmin-1;
	if(ymin<0) ymin=ymin-1;
	if(zmin<0) zmin=zmin-1;
/*      printf("The spreads are: T%f  X%f  Y%f  Z%f \n",
		spread,xspread,yspread,zspread);
	keyboard();                                   */

/*      keyboard();                                   */

						   /* Specify Light Source Location */
	light_source_spot.fx=   0.;
	light_source_spot.fy=-100.;
	light_source_spot.fz=   0.;
	mag=sqrt((light_source_spot.fx*light_source_spot.fx) +
		 (light_source_spot.fy*light_source_spot.fy) +
		 (light_source_spot.fz*light_source_spot.fz));
	light_source_normal.fx=light_source_spot.fx/mag;         /* Determine Direction Vector of Light Source */
	light_source_normal.fy=light_source_spot.fy/mag;
	light_source_normal.fz=light_source_spot.fz/mag;
	printf(" \n");
	printf("Light Source Normal Data X=%f Y=%f Z=%f Mag=%f \n",
		light_source_normal.fx,light_source_normal.fy,light_source_normal.fz,mag);

	printf(" \n");
	printf("Calculating Surface Normals \n");
	for(ipl=1; ipl<=nfaces; ipl++) {             /* read sequence of faces to be drawn */
	printf("Face # = %i \n",ipl);
	inumplate=ipl-1;                             /* step through each face           */
						     /* gather info for face to be drawn */
						     /* 0= A vertex for plate        */
						     /* 1= B vertex for plate        */
						     /* 2= C vertex for plate        */

	npoints=3;
	for(k=1; k<=npoints; k++) {                   /* visit every vertice which makes up plate to be drawn */
	npplate=npplate+1;                            /* count points which make up each plate                */
	inumvertice=faces[k-1][inumplate];            /* pick-up vertex numbers sequentially for this face */

	x=vertex[0][inumvertice];                     /* pick-up x,y,z for this vertice  */
	y=vertex[1][inumvertice];
	z=vertex[2][inumvertice];
	float3d_temp.fx=x;
	float3d_temp.fy=y;
	float3d_temp.fz=z;
	tri_face[k-1]=float3d_temp;

				    }                 /* close vertex loop for each face */

	calc_normal();                                /* Compute Surface Normal from Cross Product of Polygon Edges */

	face_normal[0][inumplate]=normal.fx;
	face_normal[1][inumplate]=normal.fy;
	face_normal[2][inumplate]=normal.fz;
/*      printf("Surface Normal Data  X=%f Y=%f Z=%f Mag=%f \n",normal.fx,normal.fy,normal.fz,mag); */
	current_face_normal.fx=face_normal[0][inumplate];
	current_face_normal.fy=face_normal[1][inumplate];
	current_face_normal.fz=face_normal[2][inumplate];

	dot_product();                  /* Perform dot product between   */
					/* current_face_normal and       */
					/* light_source_normal           */
					/* Since both vectors have Mag=1 */
					/* Dot product is COS (Theta)    */
	cos_theta=dot__product;
/*      printf("Face # = %i   Cos(Theta) = %f \n",inumplate,cos_theta);  */

				  }     /* close face loop */

	  installuserdriver("Svga256",DetectVGA256);                  /* install Super VGA 256 Color Driver */
							   /* 2 = 640 x 480 x 256 colors */
	  graphics_driver=DETECT;                          /* select desired driver and mode */
	  initgraph(&graphics_driver, &graphics_mode, ""); /* invoke video mode */

	  /* Initialize a palette with shades red, green, blue */
	  for (i=0; i<256; i++) {               /* loop through all 256 colors */
	  pal[i].red   = i/4;                     /* red    0 - 63 */
	  pal[i].green = i/4;                     /* green  0 - 63 */
	  pal[i].blue  = i/4;     }               /* blue   0 - 63 */

	 /* Issue an interupt to change the palette */
	 VGAsetpalette(pal);
	 
	cleardevice();
	setcolor(255);
	settextstyle(3,0,3);
	outtextxy(60, 30, "Z-Buffer Processing . . .");

	movez=1200.;
	rd1=0; rd2=0; rd3=0;
				       /* set up initial orientation */
	rd1=175.;
	rd2=150.;
	rd3=70.;
	r1=(pi/180.)*rd1;
	r2=(pi/180.)*rd2;
	r3=(pi/180.)*rd3;

	rotation();


	for(isection=1; isection<=48; isection++ ) {

	for(j=1; j<= 10; j++){                       /* Initialize frame_buffer and z_buffer */
	for(i=1; i<=640; i++){
	frame_buffer[i-1][j-1]=0;
	z_buffer    [i-1][j-1]=10000000.; } }

						     /* NOW DRAW THE THING  */
	for(ipl=1; ipl<=nfaces; ipl++) {             /* read sequence of faces to be drawn */
	inumplate=ipl-1;                             /* step through each face           */
						     /* gather info for face to be drawn */
						     /* 0= A vertex for plate        */
						     /* 1= B vertex for plate        */
						     /* 2= C vertex for plate        */

/*      iplate_a =faces[0][inumplate];           */
/*      iplate_b =faces[1][inumplate];           */
/*      iplate_c =faces[2][inumplate];           */
	ipen=face_color[inumplate];                  /* set pen for this plate */
	if(ipen >=15) ipen=10;
	if(ipen <= 0) ipen=10;                       /* make sure pen is visible */
/*      setcolor(ipen);                          */
/*      if(ipen!=14) goto AROUND;                */
/*      Pick-up current face normal data */
	current_face_normal.fx=face_normal[0][inumplate];
	current_face_normal.fy=face_normal[1][inumplate];
	current_face_normal.fz=face_normal[2][inumplate];

	dot_product();                  /* Perform dot product between   */
					/* current_face_normal and       */
					/* light_source_normal           */
					/* Since both vectors have Mag=1 */
					/* Dot product is COS (Theta)    */
	cos_theta=dot__product;

					/* Lambert Lighting Model        */
					/*                               */
					/* I = a + b*cos(theta)          */
					/*                               */
					/*     a = ambient light coefficient    */
					/*     b = aspect dependent coefficient */
	lambert();

	npoints=3;
	for(k=1; k<=npoints; k++) {                 /* visit every vertice which makes up plate to be drawn */
	npplate=npplate+1;                          /* count points which make up each plate                */
	inumvertice=faces[k-1][inumplate];          /* pick-up vertex numbers sequentially for this face */

	x=vertex[0][inumvertice];                   /* pick-up x,y,z for this vertice  */
	y=vertex[1][inumvertice];
	z=vertex[2][inumvertice];


	x=(x-cgx)*(375./spread);                    /* normalize and scale object coords */
	y=(y-cgy)*(375./spread);
	z=(z-cgz)*(375./spread);

	if(x==0.) x=.00001;
	if(y==0.) y=.00001;
	if(z==0.) z=.00001;

	calc_3d();                                  /* transform x,y,z  into x,y screen coords */
	sxb=sx+320.;                                  /* center object on screen */
	syb=sy+205.;                                  /* center object on screen */
	szb=z;
	point3d_temp.x=sxb;
	point3d_temp.y=syb;
	point3d_temp.z=szb;
	triangle[k-1]=point3d_temp;}                  /* close vertex loop for each face */
	polyfill_vic();                               /* Z-Buffer for Visible Surface Determination */
AROUND:
				   }                  /* close plate loop   */

/*      j_level=(y_level-1) - (100*(isection-1)); */  /* Translate y-value to buffer addresses */

/*      for(j=1; j<= 10; j++){                    */  /* Assign values to frame_buffer and z_buffer */
/*      for(i=1; i<=640; i++){                    */
/*      frame_buffer[i-1][j-1]=isection%16 ;      */
/*      z_buffer    [i-1][j-1]=1000000.; } }      */

	for(j=1; j<= 10; j++){                       /* Draw the frame_buffer */
	for(i=1; i<=640; i++){
	ipen=frame_buffer[i-1][j-1];
	j_level=(j-1) + (10*(isection-1));           /* Adjust the pixel location for this buffer section */
	putpixel(i-1, j_level, ipen);     } }        /* Draw the pixels from the frame_buffer */

					    }        /* close section loop */

	setcolor(255);
	settextstyle(5,0,2);
	outtextxy(110,  6,  "Z-BUFFER PROCESSING FOR VISIBLE SURFACE DETERMINATION");
	outtextxy(215, 16,  "   VGA  640 x 480");
	outtextxy( 82, 26,  "LAMBERT SHADING USING SURFACE NORMALS AND LIGHT SOURCE VECTOR");
	outtextxy(380,  465,"(c)   VLM  ENGINEERING  1998");
	display_palette();
	display_lighting();
	getch();            /* hold screen */
	restorecrtmode();
			  } /* close main() */

/*-------------------------------------------------------------
	SUBROUTINE: CALCULATE SIN, COS FACTORS
   Enter with r1,r2,r3 viewing angles for yaw, roll, pitch
   expressed in radians.  Returns sine and cosine factors.   */

void rotation(void){
sr1=sin(r1); sr2=sin(r2); sr3=sin(r3);
cr1=cos(r1); cr2=cos(r2); cr3=cos(r3); return;}



/*-------------------------------------------------------------
	SUBROUTINE: STANDARD 3D FORMULAS
    Enter with x,y,z cartesian world coordinates.  Returns sx,sy
    cartesian display coordinates.  Returns x,y,z cartesian view
    coordinates which includes rotation and translation effects.  */

void calc_3d(void){
x=(-1)*x; xa=cr1*x-sr1*z; za=sr1*x+cr1*z; x=cr2*xa+sr2*y;
ya=cr2*y-sr2*xa; z=cr3*za-sr3*ya; y=sr3*za+cr3*ya;
x=x+movex; y=y+movey; z=z+movez;
if(z==0.) z=.00001;
sx=d*x/z; sy=d*y/z; return;}

/*-------------------------------------------------------------
	SUBROUTINE: MAXIMUM
   Returns larger of two real numbers                          */

float maximum(float x, float y){
if(x >= y) {return x;};
if(x <= y) {return y;}; }

/*-------------------------------------------------------------
	SUBROUTINE: MINIMUM
   Returns smaller of two real numbers                         */

float minimum(float x, float y){
if(x <= y) {return x;};
if(x >= y) {return y;}; }

/*---------------------------------------------------------
	 SUBROUTINE LAMBERT
      Lambert Lighting Routine                            */

/* Lambert Lighting Model               */
/*                                      */
/* I = a + b*cos(theta)                 */
/*                                      */
/*     a = ambient light coefficient    */
/*     b = aspect dependent coefficient */

void lambert(void) {
if(cos_theta <= 0.0) {ipen = 0.28*255;/*cos_theta=cos_theta*(-1.);*/ }
		      /*  ipen =  0.25 * 255;     */
if(cos_theta >= 0.0) ipen = (0.28 + (0.72*cos_theta))*255;
return; }
/*---------------------------------------------------------
	 SUBROUTINE DISPLAY_PALETTE
	 SHOW ALL 256 COLORS IN SVGA_256 MODE            */

void display_palette(void) {
int i;
for(i=1; i<=257; i++) {
putpixel(i-1+((640-256)/2), 477, i-1);     }            /* Draw the pixels from the frame_buffer */
return; }

/*---------------------------------------------------------
	 SUBROUTINE DISPLAY_LIGHTING
	 SHOW LIGHTING CALCULATION METHOD WITH PICTURE     */

void display_lighting(void) {
int i;
setcolor(155);
moveto(20,430);
lineto(43,405);
lineto(80,405);
lineto(57,430);
lineto(20,430);
moveto(50,417);
lineto(50,388);
lineto(47,391);
lineto(50,388);
lineto(53,391);
moveto(50,417);
lineto(25,392);
settextstyle(2,0,4);
outtextxy(8,348,"LIGHTING MODEL");
outtextxy(8,357,"LAMBERT SHADING");
outtextxy(8,366,"I = A + B*COS(O)");
outtextxy(6,366,"              - ");
outtextxy(58,388,"SURFACE NORMAL");
outtextxy(3,382,"LIGHT");
outtextxy(3,390,"RAY");
outtextxy(38,386,"O");
outtextxy(38,386,"-");
return; }

/*---------------------------------------------------------
	 SUBROUTINE CALC_NORMAL
     Calculate Surface Normal Routine
     From Vector Cross Product of Face Edges             */

/* Compute Edges From Vertex Differences                 */
/* Surface Normal is Cross Product of Two Edges of Face  */
/* Normal to Vectors A and B           N = A x B         */

/* Determinant of :                  |  i  j  k  |       */
/*                                   |  ax ay az |       */
/*                                   |  bx by bz |       */

void calc_normal(void) {

float3d_one  =tri_face[0];
float3d_two  =tri_face[1];
float3d_three=tri_face[2];
/* printf("Point-1 X=%f Y=%f Z=%f \n",float3d_one.fx,float3d_one.fy,float3d_one.fz);       */
/* printf("Point-2 X=%f Y=%f Z=%f \n",float3d_two.fx,float3d_two.fy,float3d_two.fz);       */
/* printf("Point-3 X=%f Y=%f Z=%f \n",float3d_three.fx,float3d_three.fy,float3d_three.fz); */

edge_1.fx=float3d_one.fx - float3d_two.fx;               /* Compute Edges From Vertex Differences */
edge_1.fy=float3d_one.fy - float3d_two.fy;
edge_1.fz=float3d_one.fz - float3d_two.fz;
edge_2.fx=float3d_three.fx - float3d_two.fx;
edge_2.fy=float3d_three.fy - float3d_two.fy;
edge_2.fz=float3d_three.fz - float3d_two.fz;
normal.fx=(edge_1.fy*edge_2.fz) - (edge_1.fz*edge_2.fy); /* Surface Normal is Cross Product of Two Edges of Face */
normal.fy=(edge_1.fz*edge_2.fx) - (edge_1.fx*edge_2.fz); /* Vectors A and B           N = A x B                  */
normal.fz=(edge_1.fx*edge_2.fy) - (edge_1.fy*edge_2.fx);
							 /* Determinant of :        |  i  j  k  |     */
							 /*                         |  ax ay az |     */
							 /*                         |  bx by bz |     */

mag=sqrt((normal.fx*normal.fx) +                         /* Normalize Direction Vector */
	 (normal.fy*normal.fy) +
	 (normal.fz*normal.fz));


normal.fx = normal.fx / mag;
normal.fy = normal.fy / mag;
normal.fz = normal.fz / mag;
return; }

/*---------------------------------------------------------
	 SUBROUTINE DOT_PRODUCT
     Calculate Dot Product Routine                       */

/* Compute Dot Product Between Two Vectors               */
/*                                                       */
/* Dot Product of two Vectors A and B      P = A . B     */
/*                                                       */
/*                                  A=  ax ay az         */
/*                                  B=  bx by bz         */ 
/*                                                       */
/*       P= ax*bx + ay*by + az*bz                        */
/*                                                       */
/*       P= |A| |B| cos(theta)                           */
/*                                                       */
/*       When A, B unit vectors Magnitude = 1            */
/*       Dot Product is cos(theta)                       */

void dot_product(void) {

dot__product=((light_source_normal.fx*current_face_normal.fx) +
	      (light_source_normal.fy*current_face_normal.fy) +
	      (light_source_normal.fz*current_face_normal.fz)) ;
return; }                                                
							
/*--------------------------------------------------------------
	 SUBROUTINE POLYFILL_VIC
    Polygon Fill Routine With Depth Value Plane Equation        */

void polyfill_vic(void) {

/* setcolor(ipen); */                              /* Set Color of Face     */

point3d_one=triangle[0];
point3d_two=triangle[1];
point3d_three=triangle[2];

						   /* Get All Three Points Ordered By Y-Values */
if(point3d_two.y < point3d_one.y)
{ point3d_temp=point3d_one; point3d_one=point3d_two; point3d_two=point3d_temp;}        /* swap */
if(point3d_three.y < point3d_one.y)
{ point3d_temp=point3d_one; point3d_one=point3d_three; point3d_three=point3d_temp;}    /* swap */
if(point3d_three.y < point3d_two.y)
{ point3d_temp=point3d_two; point3d_two=point3d_three; point3d_three=point3d_temp;}    /* swap */
if(point3d_two.y < point3d_one.y)
{ point3d_temp=point3d_one; point3d_one=point3d_two; point3d_two=point3d_temp;}        /* swap */
if(point3d_three.y < point3d_one.y)
{ point3d_temp=point3d_one; point3d_one=point3d_three; point3d_three=point3d_temp;}    /* swap */
if(point3d_three.y < point3d_two.y)
{ point3d_temp=point3d_two; point3d_two=point3d_three; point3d_three=point3d_temp;}    /* swap */

/*  printf("Subroutine Polyfill_Vic \n");                                                 */
/*  printf("All Three Triangle Points Sorted By Y-Value \n");                             */
/*  printf("X1= %i  Y1= %i   Z1= %i \n",point3d_one.x,point3d_one.y,point3d_one.z);       */
/*  printf("X2= %i  Y2= %i   Z2= %i \n",point3d_two.x,point3d_two.y,point3d_two.z);       */
/*  printf("X3= %i  Y3= %i   Z3= %i \n",point3d_three.x,point3d_three.y,point3d_three.z); */

/* All three points on a horizontal line */
if(point3d_one.y == point3d_two.y) {
if(point3d_one.y == point3d_three.y) {goto BYPASS ; } }
/* All three points on a vertical line */
if(point3d_one.x == point3d_two.x) {
if(point3d_one.x == point3d_three.x) {goto BYPASS ; } }

icase=0;                                                           /* Start with dx1 < dx2 */
ibypass=0;                                                         /* Used to flag when pt2.y == pt3.y */
if(point3d_one.y == point3d_two.y  ) {xhgh=point3d_one.x; zhgh=point3d_one.z;
				      xlow=point3d_two.x; zlow=point3d_two.z;
				      if(point3d_two.x > point3d_one.x) { icase=1;
				      xhgh=point3d_two.x; zhgh=point3d_two.z;
				      xlow=point3d_one.x; zlow=point3d_one.z;}     goto SPAN2to3; }
if(point3d_two.y == point3d_three.y) {ibypass=1;                                   goto SPAN1to2; }

SPAN1to2:
/* Compute Span Limits For Vertice 1 to 2        */
/* Compute Span Limit Increment Sizes Per Y Step */
/* Compute Delta-X on Left and Right   Compute Delta-Z on Left and Right */
dx1=(point3d_two.x - point3d_one.x)   / (1.*(point3d_two.y   - point3d_one.y));
dz1=(point3d_two.z - point3d_one.z)   / (1.*(point3d_two.y   - point3d_one.y));
dx2=(point3d_three.x - point3d_one.x) / (1.*(point3d_three.y - point3d_one.y));
dz2=(point3d_three.z - point3d_one.z) / (1.*(point3d_three.y - point3d_one.y));

if(dx2 < dx1) icase=1;                                             /* Flag cases with    dx2 < dx1  */

if(icase==1) {                                                     /* Reverse Limits for dx2 < dx1  */
dx1=(point3d_three.x - point3d_one.x)   / (1.*(point3d_three.y   - point3d_one.y));
dz1=(point3d_three.z - point3d_one.z)   / (1.*(point3d_three.y   - point3d_one.y));
dx2=(point3d_two.x - point3d_one.x)     / (1.*(point3d_two.y     - point3d_one.y));
dz2=(point3d_two.z - point3d_one.z)     / (1.*(point3d_two.y     - point3d_one.y));  }

istep=0;
for(jj=point3d_one.y; jj<=point3d_two.y; jj++) {                                 /* Step Down Face in Y */

xlow=point3d_one.x + istep*dx1;                                               /* Determine X Span Limits - Low and High */
xhgh=point3d_one.x + istep*dx2;
zlow=point3d_one.z + istep*dz1;                                               /* Determine Z Span Limits - Low and High */
zhgh=point3d_one.z + istep*dz2;
if(xhgh==xlow) { dzstep=0;}                                  /* Avoid divide by zero */
if(xhgh!=xlow) {dzstep=(zhgh - zlow) / (1.*(xhgh - xlow));}

istep=istep+1;

j_level=(jj-1) - (10*(isection-1));            /* Compute Adjusted Y-value for this section */
idrawflag=1;                                   /* Current Y-level within this section range */
if(j_level<0) idrawflag=0 ;                    /* Do not draw if out of bounds              */
if(j_level>9) idrawflag=0 ;                    /* Do not draw if out of bounds              */

ispanstep=0;
for(ispan=xlow; ispan<=xhgh; ispan ++) {
zdepth=zlow + ispanstep*dzstep;
ispanstep=ispanstep+1;
if(idrawflag==1) {
if(zdepth < z_buffer[ispan][j_level]) { frame_buffer[ispan][j_level]=ipen;           /* Compare Depth Z-Value At Each Pixel */
					    z_buffer[ispan][j_level]=zdepth;} } } }  /* To Determine If Should Draw New Color */

if(ibypass==1) goto BYPASS;                                                   /* Bypass For case when pt2.y == pt3.y */

/* Save Intermediate Points After Second Vertice */

SPAN2to3:
xhgh_hold=xhgh;
xlow_hold=xlow;
yhgh_hold=point3d_two.y;
zhgh_hold=zhgh;
zlow_hold=zlow;

/* Compute New Span Limits For Vertice 2 to 3    */
/* Compute Span Limit Increment Sizes Per Y Step */
/* Compute Delta-X on Left and Right   Compute Delta-Z on Left and Right */
dx1=(point3d_three.x - point3d_two.x)   / (1.*(point3d_three.y - point3d_two.y));
dz1=(point3d_three.z - point3d_two.z)   / (1.*(point3d_three.y - point3d_two.y));
dx2=(point3d_three.x - xhgh_hold)       / (1.*(point3d_three.y - point3d_two.y));
dz2=(point3d_three.z - zhgh_hold)       / (1.*(point3d_three.y - point3d_two.y));
if(icase==1) {                                                                     /* Reverse Limits for dx2 < dx1 */
dx1=(point3d_three.x - xlow_hold    )   / (1.*(point3d_three.y   - point3d_two.y));
dz1=(point3d_three.z - zlow_hold    )   / (1.*(point3d_three.y   - point3d_two.y));
dx2=(point3d_three.x - point3d_two.x)   / (1.*(point3d_three.y   - point3d_two.y));
dz2=(point3d_three.z - point3d_two.z)   / (1.*(point3d_three.y   - point3d_two.y));  }


istep=0;
for(jj=point3d_two.y; jj<=point3d_three.y; jj++) {                               /* Step Down Face in Y */

xlow=point3d_two.x + istep*dx1;                                               /* Determine X Span Limits - Low and High */
xhgh=xhgh_hold     + istep*dx2;
zlow=point3d_two.z + istep*dz1;                                               /* Determine Z Span Limits - Low and High */
zhgh=zhgh_hold     + istep*dz2;

if(icase==1) {                                                                /* Compute X Span Limits for dx2 < dx1 */
xlow=xlow_hold     + istep*dx1;
xhgh=point3d_two.x + istep*dx2;
zlow=zlow_hold     + istep*dz1;                                               /* Compute Z Span Limits for dx2 < dx1 */
zhgh=point3d_two.z + istep*dz2;   }

if(xhgh==xlow) { dzstep=0;}                                  /* Avoid divide by zero */
if(xhgh!=xlow) {dzstep=(zhgh - zlow) / (1.*(xhgh - xlow));}

istep=istep+1;

j_level=(jj-1) - (10*(isection-1));            /* Compute Adjusted Y-value for this section */
idrawflag=1;                                   /* Current Y-level within this section range */
if(j_level<0) idrawflag=0 ;                    /* Do not draw if out of bounds              */
if(j_level>9) idrawflag=0 ;                    /* Do not draw if out of bounds              */

ispanstep=0;
for(ispan=xlow; ispan<=xhgh; ispan ++) {
zdepth=zlow + ispanstep*dzstep;
ispanstep=ispanstep+1;
if(idrawflag==1) {
if(zdepth < z_buffer[ispan][j_level]) { frame_buffer[ispan][j_level]=ipen;           /* Compare Depth Z-Value At Each Pixel */
					    z_buffer[ispan][j_level]=zdepth;} } } }  /* To Determine If Should Draw New Color */

BYPASS:
return; }
