/**************************************/
/*   Z-Buffer Drawing Program         */
/*                                    */
/*   (c) Victor L. Miller    Nov 1997 */
/*                                    */
/*   Use Z-Buffer and Frame-Buffer    */
/*   For Visible Surface Determination*/
/**************************************/
/**************************************/
/*    3-D OBJECT DRAWING PROGRAM      */
/*    V. MILLER  JUNE 1997            */
/*    3-D PROJECTION DRAWING PROGRAM  */
/*                                    */
/*    DEPTH SORT FOR HIDDEN POLYGONS  */
/*                                    */
/*    READS *._3D FILES WHICH ARE     */
/*    ASCII VERSIONS OF BINARY *.3DS  */
/*    FILES                           */
/*                                    */
/*    *.3DS FILES ARE CONVERTED TO    */
/*    ASCII *._3D FILES WITH PROGRAM  */
/*    3DSRDR.C FROM FINLAND (x2ftp)   */
/**************************************/

#include <dos.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <graphics.h>      /* Borland BGI - requires driver file EGAVGA.BGI */
#include <alloc.h>
#include <bios.h>
#include <process.h>
int graphics_adapter,graphics_mode;
int ixpt,iypt,ipen,i,ipl,iv,ivert,j,k,p,istyle,ixtxt,iytxt,i_spin;
int nvert,nplate,npvert,nfaces,aa,bb,cc,icolor,itemp;
int inumplate,inumvertice,istartplate,index,npoints,npplate;
float zdepth;
int face_color[1000];
float scicon,pilotx,piloty,pilotz,vertex[3][1000],faces[3][1000];
float x,y,z,cgx,cgy,cgz;
double xx,yy,zz;
float xa=0.,ya=0.,za=0.;
float xmax,xmin,ymax,ymin,zmax,zmin,xspread,yspread,zspread,spread;
float xmiddle,ymiddle,zmiddle;
float r1=0.,r2=0.,r3=0.;
float sr1=0., sr2=0., sr3=0.;
float cr1=0., cr2=0., cr3=0.;
float rd1=0,rd2=0,rd3=0;
int hertz=100, duration=10000;
float movex=0.,movey=0.,movez=300.;
float sx=0.,sy=0.;
float sxavg,syavg,sxstart,systart,sxseed,syseed;
float sxa=0., sya=0., sxb=0., syb=0., szb;
float pi=3.141592, d=1200.,a;
float angle,range,radius,xcenter,ycenter,xpt,ypt,xout,yout,xin,yin;
int   iloop, iloop2, iswapflag=1, ipoint, iface;
int   isection, j_level, icase, ibypass, jj;
int iplate_a,iplate_b,iplate_c;
int zin,zout,c;
char string[80],string_value[4],str_pointer;
int istring_start,ivalue,ivert,ix,iy,iz;
float tempiplate, tempzdepth;
int ispan, istep, ispanstep, idrawflag;
float dx1, dx2, dz1, dz2, dzstep, zlow, zhgh, zdepth, zlow_hold, zhgh_hold;
int    xlow, xhgh, xlow_hold, xhgh_hold, yhgh_hold;

typedef struct { int x,y,z ; } point3d;
point3d triangle[3], point3d_one, point3d_two, point3d_three, point3d_temp;

unsigned char far frame_buffer [640][50];       /* Frame Buffer For Pixel Color Values */
						/* Unsigned Char Is One Byte Per Location  = 64 K Array */
						/* With Unsigned Char Can Go To [640][100] = 64 K Array */
/*int           far frame_buffer [640][50]; */  /* Frame Buffer For Pixel Color Values */
						/* Integer Is Two Bytes Per Location   */
float far   z_buffer [640][25];      /*     Z-Buffer For Pixel Depth Values */
float far   z_buffer2[640][25];      /*     Z-Buffer For Pixel Depth Values */
				     /* Use far keyword to get individual   */
				     /* 64 K segment for arrays             */
int t1=0,t2=0,p1=0;
char dummy,buffer[80];
FILE *fp;
void keyboard(void);
void keyboard_input(void);
void calc_3d(void);
void rotation(void);
void vic_sort(void);
float maximum(float x,float y);
float minimum(float x,float y);
void polyfill_vic(void);

main()
{
	fp=fopen("engine._3d","r");         /* open icon file */
/*      printf("Opened File \n");   */
	ipoint=0;
	iface=0;
	while(feof(fp) == 0) {              /* read until End-Of-File is reached */
/*      fread(&string,80,1,fp);  */         /* read line as string */
	fgets(string,80,fp);                /* read line from file as string */
/*      for(i=1;i<=80;i++) {
	printf("%c",string[i-1]); }  */

	istring_start=0;
	str_pointer=strstr(string,"Vertices:");
	if(str_pointer!=NULL) {
/*      printf("Vertices: found at position %i \n",str_pointer);
	for(i=1;i<=80;i++) {printf("%c",string[i-1]);}
	keyboard();                                      */
	sscanf(string,"%*s%d",&nvert);
/*      printf("The number of verticies assigned is %i \n",nvert); */
	str_pointer=NULL;
/*      keyboard();        */                         }

	str_pointer=strstr(string,"X:");
	if(str_pointer!=NULL) {
/*      printf("Found X: Y: Z: Data \n");
	for(i=1;i<=80;i++) {printf("%c",string[i-1]);}    */
/*      sscanf(string,"%*s%f, %*s%f, %*s%f\n",&x,&y,&z);  */
	sscanf(string,"              X: %f, Y: %f, Z: %f",&x,&y,&z);
	vertex[0][ipoint]=x;
	vertex[1][ipoint]=y;
	vertex[2][ipoint]=z;
	ipoint=ipoint+1;

	xmax=maximum(xmax,x);                  /* find x,y,z mins and maxs for scaling */
	xmin=minimum(xmin,x);
	ymax=maximum(ymax,y);
	ymin=minimum(ymin,y);
	zmax=maximum(zmax,z);
	zmin=minimum(zmin,z);

/*      for(j=1;j<=ivert;j++) {
	fscanf(fp,"%*s%d%*s%d%*s%d \n",&x,&y,&z);   */
/*      printf("Assigned X: %f Y: %f Z: %f \n",x,y,z); */
	str_pointer=NULL;
	/* keyboard(); */   }

	str_pointer=strstr(string,"Faces:");
	if(str_pointer!=NULL) {
/*      printf("Found Face Number \n");        */
	sscanf(string,"%*s%d",&nfaces);
/*      printf("The number of faces is %i \n",nfaces);   */
	str_pointer=NULL;
/*      keyboard();        */    }

	str_pointer=strstr(string,"A:");
	if(str_pointer!=NULL) {
/*      printf("Found Face Data \n");      */
	sscanf(string,"      A: %i, B: %i, C: %i,%i",&aa,&bb,&cc,&icolor);
	faces[0][iface]=aa;
	faces[1][iface]=bb;
	faces[2][iface]=cc;
	face_color[iface]=icolor;
	iface=iface+1;

/*	printf("Assigned Face A: %i B: %i C: %i D: %i \n",aa,bb,cc,icolor); */
	str_pointer=NULL;
	/* keyboard(); */           }
				  }               /* End-Of-File */
/*      printf("Finished Reading Object File");
	keyboard();                             */
	xspread=xmax - xmin;                      /* Find biggest spread in x,y,z */
	yspread=ymax - ymin;
	zspread=zmax - zmin;
	spread=maximum(xspread,yspread);
	spread=maximum(spread,zspread);
	cgx=(xmax+xmin)/2.;
	cgy=(ymax+ymin)/2.;
	cgz=(zmax+zmin)/2.;
	if(xmin<0) xmin=xmin-1;
	if(ymin<0) ymin=ymin-1;
	if(zmin<0) zmin=zmin-1;
/*      printf("The spreads are: T%f  X%f  Y%f  Z%f \n",
		spread,xspread,yspread,zspread);
	keyboard();                                   */

/*      keyboard();                                   */

	detectgraph(&graphics_adapter,&graphics_mode);
	graphics_adapter=EGA; graphics_mode=EGAHI;
	initgraph(&graphics_adapter,&graphics_mode,"");
	cleardevice();
	settextstyle(3,0,1);
	setcolor(10);
	outtextxy(60, 30, "Z-Buffer Processing . . .");

	movez=1200.;
	rd1=0; rd2=0; rd3=0;
				       /* set up initial orientation */
				/* Starting Orientations : */
	rd1=175.;               /* rd1 = 175.              */
	rd2=135.;               /* rd1 = 135. or -5.       */
	rd3= 70.;               /* rd3 =  70.              */

	for(i_spin=1; i_spin<=54; i_spin++) {

	if(p==1) { setvisualpage(1);        /* DO DOUBLE-BUFFERING */
	for(j=1; j<=6500; j++) {a=sin(1.);}
		   setactivepage(0);}
	if(p==0) { setvisualpage(0);
	for(j=1; j<=6500; j++) {a=sin(1.);}
		   setactivepage(1);}
	p=1-p;

/*      rd1=rd1+20;   */
	rd2=rd2+20;                         /* Rotate in 20 degree steps */
/*      rd3=rd3+20;   */

	r1=(pi/180.)*rd1;
	r2=(pi/180.)*rd2;
	r3=(pi/180.)*rd3;

	rotation();


	for(isection=1; isection<=7; isection++ ) {  /* Buffer Complete Screen In Horizontal Sections */
						     /* Width of Each Section Depends Upon Storage Array Size */
	if(i_spin==1) {                              /* keep screen active during initialization */
	setactivepage(0);
	outtextxy(76+(25*isection), 172, ".");
	setactivepage(1); }

	for(j=1; j<= 25; j++){                       /* Initialize frame_buffer and z_buffer */
	for(i=1; i<=640; i++){
	frame_buffer[i-1][j-1]=0;
	frame_buffer[i-1][j-1+25]=0;
	z_buffer    [i-1][j-1]=10000000.;
	z_buffer2   [i-1][j-1]=10000000.;  } }

						     /* NOW DRAW THE THING  */
	for(ipl=1; ipl<=nfaces; ipl++) {             /* read sequence of faces to be drawn */
	inumplate=ipl-1;                             /* step through each face           */
						     /* gather info for face to be drawn */
						     /* 0= A vertex for plate        */
						     /* 1= B vertex for plate        */
						     /* 2= C vertex for plate        */

/*      iplate_a =faces[0][inumplate];           */
/*      iplate_b =faces[1][inumplate];           */
/*      iplate_c =faces[2][inumplate];           */
	ipen=face_color[inumplate];                  /* set pen for this plate */
	if(ipen >=15) ipen=10;
	if(ipen <= 0) ipen=10;                       /* make sure pen is visible */
/*     	setcolor(ipen);                          */

	npoints=3;
	for(k=1; k<=npoints; k++) {                   /* visit every vertice which makes up plate to be drawn */
	npplate=npplate+1;                            /* count points which make up each plate                */
	inumvertice=faces[k-1][inumplate];            /* pick-up vertex numbers sequentially for this face */

	x=vertex[0][inumvertice];                     /* pick-up x,y,z for this vertice  */
	y=vertex[1][inumvertice];
	z=vertex[2][inumvertice];


	x=(x-cgx)*(375./spread);                  /* normalize and scale object coords */
	y=(y-cgy)*(375./spread);
	z=(z-cgz)*(375./spread);

	if(x==0.) x=.00001;
	if(y==0.) y=.00001;
	if(z==0.) z=.00001;

	calc_3d();                                    /* transform x,y,z  into x,y screen coords */
	sxb=sx+310.;                                  /* center object on screen */
	syb=sy+170.;                                  /* center object on screen */
	szb=z;
	point3d_temp.x=sxb;
	point3d_temp.y=syb;
	point3d_temp.z=szb;
	triangle[k-1]=point3d_temp;}                  /* close vertex loop for each face */
	polyfill_vic();                               /* Z-Buffer for Visible Surface Determination */
				   }                  /* close plate loop   */

/*      j_level=(y_level-1) - (100*(isection-1)); */  /* Translate y-value to buffer addresses */

/*      for(j=1; j<= 25; j++){                    */  /* Assign values to frame_buffer and z_buffer */
/*      for(i=1; i<=640; i++){                    */
/*      frame_buffer[i-1][j-1]=isection%16 ;      */
/*      z_buffer    [i-1][j-1]=1000000.; } }      */

	for(j=1; j<= 50; j++){                       /* Draw the frame_buffer */
	for(i=1; i<=640; i++){
	ipen=frame_buffer[i-1][j-1];
	j_level=(j-1) + (50*(isection-1));           /* Adjust the pixel location for this buffer section */
	putpixel(i-1, j_level, ipen);     } }        /* Draw the pixels from the frame_buffer */

					    }        /* close section loop */

	setcolor(15);
	settextstyle(0,0,1);
	outtextxy(100,  1,  "Z-BUFFER PROCESSING FOR VISIBLE SURFACE DETERMINATION");
	outtextxy(100, 11,  "    DOUBLE-BUFFERING FOR ANIMATION PAGE FLIPPING");
	outtextxy(205, 20,  "   VGA  640 x 480");
	settextstyle(2,0,4);
	outtextxy(1,  340,  "(c) VICTOR L. MILLER  1997");
	outtextxy(488,340,  "Press <ESC> to Quit");
	if(kbhit()!=0) goto END;             }         /* close i_spin rotation loop */
END:
	getch();   /* hold screen */         }         /* close main() */

/*-------------------------------------------------------------
	SUBROUTINE: CALCULATE SIN, COS FACTORS
   Enter with r1,r2,r3 viewing angles for yaw, roll, pitch
   expressed in radians.  Returns sine and cosine factors.   */

void rotation(void){
sr1=sin(r1); sr2=sin(r2); sr3=sin(r3);
cr1=cos(r1); cr2=cos(r2); cr3=cos(r3); return;}



/*-------------------------------------------------------------
	SUBROUTINE: STANDARD 3D FORMULAS
    Enter with x,y,z cartesian world coordinates.  Returns sx,sy
    cartesian display coordinates.  Returns x,y,z cartesian view
    coordinates which includes rotation and translation effects.  */

void calc_3d(void){
x=(-1)*x; xa=cr1*x-sr1*z; za=sr1*x+cr1*z; x=cr2*xa+sr2*y;
ya=cr2*y-sr2*xa; z=cr3*za-sr3*ya; y=sr3*za+cr3*ya;
x=x+movex; y=y+movey; z=z+movez;
if(z==0.) z=.00001;
sx=d*x/z; sy=d*y/z; return;}

/*-------------------------------------------------------------
	SUBROUTINE: MAXIMUM
   Returns larger of two real numbers                          */

float maximum(float x, float y){
if(x >= y) {return x;};
if(x <= y) {return y;}; }

/*-------------------------------------------------------------
	SUBROUTINE: MINIMUM
   Returns smaller of two real numbers                         */

float minimum(float x, float y){
if(x <= y) {return x;};
if(x >= y) {return y;}; }

/*--------------------------------------------------------------
	SUBROUTINE:  KEYBOARD - SCREEN HOLD UNTIL ESC KEY       */
void keyboard(void){
union u_type{int a; char b[3];} keystroke;
int get_keystroke(void);
do keystroke.a=get_keystroke();
while (keystroke.b[0]!=110); }

int get_keystroke(void){
union REGS regs;regs.h.ah=0; return int86(0x16,&regs,&regs);}

/*--------------------------------------------------------------
	SUBROUTINE: DYNAMIC KEYBOARD INPUT
							       */
void keyboard_input(void){
union u_type{int a; char b[3];}keystroke; char inkey=0;

if(bioskey(1)==0) return;                   /* if no key, return      */
keystroke.a=bioskey(0);                     /* fetch ASCII code...    */
inkey=keystroke.b[0];                       /* ... and load code into variable */
switch (inkey) {                            /* make decision based upon ASCII value */
case 27:  exit(0);                          /* exit on <Esc> key      */
case 61:  movez=movez+20; return;           /* + key = move outwards  */
case 45:  movez=movez-20; return;           /* - key = move inwards   */
case 104: rd1=rd1-2;      return;           /* h key roll right       */
case 102: rd1=rd1+2;      return;           /* f key roll left        */
case 103: rd1=0;rd2=0;rd3=0; return;        /* g key return to nominal position */
case 116: rd2=rd2+2;      return;           /* t key pitch forward    */
case 98:  rd2=rd2-2;      return;           /* b key pitch back       */
case 118: rd3=rd3-2;      return;           /* v key yaw back         */
case 121: rd3=rd3+2;      return;           /* y key yaw forward      */

default: return;} }                         /* make routine bullet-proof */

/*--------------------------------------------------------------------------
	 SUBROUTINE POLYFILL_VIC
    Polygon Fill Routine With Depth Value Plane Equation        */

void polyfill_vic(void) {

/* setcolor(ipen); */                              /* Set Color of Face     */

point3d_one=triangle[0];
point3d_two=triangle[1];
point3d_three=triangle[2];

						   /* Get All Three Points Ordered By Y-Values */
if(point3d_two.y < point3d_one.y)
{ point3d_temp=point3d_one; point3d_one=point3d_two; point3d_two=point3d_temp;}        /* swap */
if(point3d_three.y < point3d_one.y)
{ point3d_temp=point3d_one; point3d_one=point3d_three; point3d_three=point3d_temp;}    /* swap */
if(point3d_three.y < point3d_two.y)
{ point3d_temp=point3d_two; point3d_two=point3d_three; point3d_three=point3d_temp;}    /* swap */
if(point3d_two.y < point3d_one.y)
{ point3d_temp=point3d_one; point3d_one=point3d_two; point3d_two=point3d_temp;}        /* swap */
if(point3d_three.y < point3d_one.y)
{ point3d_temp=point3d_one; point3d_one=point3d_three; point3d_three=point3d_temp;}    /* swap */
if(point3d_three.y < point3d_two.y)
{ point3d_temp=point3d_two; point3d_two=point3d_three; point3d_three=point3d_temp;}    /* swap */

/*  printf("Subroutine Polyfill_Vic \n");                                                 */
/*  printf("All Three Triangle Points Sorted By Y-Value \n");                             */
/*  printf("X1= %i  Y1= %i   Z1= %i \n",point3d_one.x,point3d_one.y,point3d_one.z);       */
/*  printf("X2= %i  Y2= %i   Z2= %i \n",point3d_two.x,point3d_two.y,point3d_two.z);       */
/*  printf("X3= %i  Y3= %i   Z3= %i \n",point3d_three.x,point3d_three.y,point3d_three.z); */
/*  getch();

/* All three points on a horizontal line */
if(point3d_one.y == point3d_two.y) {
if(point3d_one.y == point3d_three.y) {goto BYPASS ; } }
/* All three points on a vertical line */
if(point3d_one.x == point3d_two.x) {
if(point3d_one.x == point3d_three.x) {goto BYPASS ; } }

icase=0;                                                           /* Start with dx1 < dx2 */
ibypass=0;                                                         /* Used to flag when pt2.y == pt3.y */
if(point3d_one.y == point3d_two.y  ) {xhgh=point3d_one.x; zhgh=point3d_one.z;
				      xlow=point3d_two.x; zlow=point3d_two.z;
				      if(point3d_two.x > point3d_one.x) { icase=1;
				      xhgh=point3d_two.x; zhgh=point3d_two.z;
				      xlow=point3d_one.x; zlow=point3d_one.z;}     goto SPAN2to3; }
if(point3d_two.y == point3d_three.y) {ibypass=1;                                   goto SPAN1to2; }

SPAN1to2:
/* Compute Span Limits For Vertice 1 to 2        */
/* Compute Span Limit Increment Sizes Per Y Step */
/* Compute Delta-X on Left and Right   Compute Delta-Z on Left and Right */
dx1=(point3d_two.x - point3d_one.x)   / (1.*(point3d_two.y   - point3d_one.y));
dz1=(point3d_two.z - point3d_one.z)   / (1.*(point3d_two.y   - point3d_one.y));
dx2=(point3d_three.x - point3d_one.x) / (1.*(point3d_three.y - point3d_one.y));
dz2=(point3d_three.z - point3d_one.z) / (1.*(point3d_three.y - point3d_one.y));

if(dx2 < dx1) icase=1;                                             /* Flag cases with    dx2 < dx1  */

if(icase==1) {                                                     /* Reverse Limits for dx2 < dx1  */
dx1=(point3d_three.x - point3d_one.x)   / (1.*(point3d_three.y   - point3d_one.y));
dz1=(point3d_three.z - point3d_one.z)   / (1.*(point3d_three.y   - point3d_one.y));
dx2=(point3d_two.x - point3d_one.x)     / (1.*(point3d_two.y     - point3d_one.y));
dz2=(point3d_two.z - point3d_one.z)     / (1.*(point3d_two.y     - point3d_one.y));  }

istep=0;
for(jj=point3d_one.y; jj<=point3d_two.y; jj++) {                                 /* Step Down Face in Y */

xlow=point3d_one.x + istep*dx1;                                               /* Determine X Span Limits - Low and High */
xhgh=point3d_one.x + istep*dx2;
zlow=point3d_one.z + istep*dz1;                                               /* Determine Z Span Limits - Low and High */
zhgh=point3d_one.z + istep*dz2;
if(xhgh==xlow) { dzstep=0;}                                  /* Avoid divide by zero */
if(xhgh!=xlow) {dzstep=(zhgh - zlow) / (1.*(xhgh - xlow));}

istep=istep+1;

j_level=(jj-1) - (50*(isection-1));            /* Compute Adjusted Y-value for this section */
idrawflag=1;                                   /* Current Y-level within this section range */
if(j_level<0)  idrawflag=0 ;                   /* Do not draw if out of bounds              */
if(j_level>49) idrawflag=0 ;                   /* Do not draw if out of bounds              */

ispanstep=0;
for(ispan=xlow; ispan<=xhgh; ispan ++) {
zdepth=zlow + ispanstep*dzstep;
ispanstep=ispanstep+1;
if(idrawflag==1) {
if(j_level<=24) {
if(zdepth < z_buffer[ispan][j_level]) { frame_buffer[ispan][j_level]=ipen;             /* Compare Depth Z-Value At Each Pixel */
					    z_buffer[ispan][j_level]=zdepth;} }        /* To Determine If Should Draw New Color */
if(j_level>=25) {
if(zdepth < z_buffer2[ispan][j_level-25]) { frame_buffer[ispan][j_level]=ipen;             /* Compare Depth Z-Value At Each Pixel */
					    z_buffer2[ispan][j_level-25]=zdepth;} } } } }  /* To Determine If Should Draw New Color */

if(ibypass==1) goto BYPASS;                                                   /* Bypass For case when pt2.y == pt3.y */

/* Save Intermediate Points After Second Vertice */

SPAN2to3:
xhgh_hold=xhgh;
xlow_hold=xlow;
yhgh_hold=point3d_two.y;
zhgh_hold=zhgh;
zlow_hold=zlow;

/* Compute New Span Limits For Vertice 2 to 3    */
/* Compute Span Limit Increment Sizes Per Y Step */
/* Compute Delta-X on Left and Right   Compute Delta-Z on Left and Right */
dx1=(point3d_three.x - point3d_two.x)   / (1.*(point3d_three.y - point3d_two.y));
dz1=(point3d_three.z - point3d_two.z)   / (1.*(point3d_three.y - point3d_two.y));
dx2=(point3d_three.x - xhgh_hold)       / (1.*(point3d_three.y - point3d_two.y));
dz2=(point3d_three.z - zhgh_hold)       / (1.*(point3d_three.y - point3d_two.y));
if(icase==1) {                                                                     /* Reverse Limits for dx2 < dx1 */
dx1=(point3d_three.x - xlow_hold    )   / (1.*(point3d_three.y   - point3d_two.y));
dz1=(point3d_three.z - zlow_hold    )   / (1.*(point3d_three.y   - point3d_two.y));
dx2=(point3d_three.x - point3d_two.x)   / (1.*(point3d_three.y   - point3d_two.y));
dz2=(point3d_three.z - point3d_two.z)   / (1.*(point3d_three.y   - point3d_two.y));  }


istep=0;
for(jj=point3d_two.y; jj<=point3d_three.y; jj++) {                               /* Step Down Face in Y */

xlow=point3d_two.x + istep*dx1;                                               /* Determine X Span Limits - Low and High */
xhgh=xhgh_hold     + istep*dx2;
zlow=point3d_two.z + istep*dz1;                                               /* Determine Z Span Limits - Low and High */
zhgh=zhgh_hold     + istep*dz2;

if(icase==1) {                                                                /* Compute X Span Limits for dx2 < dx1 */
xlow=xlow_hold     + istep*dx1;
xhgh=point3d_two.x + istep*dx2;
zlow=zlow_hold     + istep*dz1;                                               /* Compute Z Span Limits for dx2 < dx1 */
zhgh=point3d_two.z + istep*dz2;   }

if(xhgh==xlow) { dzstep=0;}                                  /* Avoid divide by zero */
if(xhgh!=xlow) {dzstep=(zhgh - zlow) / (1.*(xhgh - xlow));}

istep=istep+1;

j_level=(jj-1) - (50*(isection-1));            /* Compute Adjusted Y-value for this section */
idrawflag=1;                                   /* Current Y-level within this section range */
if(j_level<0)  idrawflag=0 ;                   /* Do not draw if out of bounds              */
if(j_level>49) idrawflag=0 ;                   /* Do not draw if out of bounds              */

ispanstep=0;
for(ispan=xlow; ispan<=xhgh; ispan ++) {
zdepth=zlow + ispanstep*dzstep;
ispanstep=ispanstep+1;
if(idrawflag==1) {
if(j_level<=24) {
if(zdepth < z_buffer[ispan][j_level]) { frame_buffer[ispan][j_level]=ipen;             /* Compare Depth Z-Value At Each Pixel */
					    z_buffer[ispan][j_level]=zdepth;} }        /* To Determine If Should Draw New Color */
if(j_level>=25) {
if(zdepth < z_buffer2[ispan][j_level-25]) { frame_buffer[ispan][j_level]=ipen;             /* Compare Depth Z-Value At Each Pixel */
					    z_buffer2[ispan][j_level-25]=zdepth;} } } } }  /* To Determine If Should Draw New Color */

BYPASS:
return; }

