/**************************************/
/*   Z-Buffer Drawing Program         */
/*                                    */
/*   Victor L. Miller    Nov 1997     */
/*                                    */
/*   Use Z-Buffer and Frame-Buffer    */
/*   For Visible Surface Determination*/
/**************************************/
/**************************************/
/*    3-D OBJECT DRAWING PROGRAM      */
/*    V. MILLER  JUNE 1997            */
/*    3-D PROJECTION DRAWING PROGRAM  */
/*                                    */
/*    DEPTH SORT FOR HIDDEN POLYGONS  */
/*                                    */
/*    READS *._3D FILES WHICH ARE     */
/*    ASCII VERSIONS OF BINARY *.3DS  */
/*    FILES                           */
/*                                    */
/*    *.3DS FILES ARE CONVERTED TO    */
/*    ASCII *._3D FILES WITH PROGRAM  */
/*    3DSRDR.C FROM FINLAND (x2ftp)   */
/**************************************/

#include <dos.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <graphics.h>
#include <alloc.h>
#include <bios.h>
#include <process.h>
int graphics_adapter,graphics_mode;
int ixpt,iypt,ipen,i,ipl,iv,ivert,j,k,p,istyle,ixtxt,iytxt;
int nvert,nplate,npvert,nfaces,aa,bb,cc,icolor,itemp;
int inumplate,inumvertice,istartplate,index,npoints,npplate;
int sxsave, sysave, sxlast, sylast;
float zdepth;
float x,y,z;
double xx,yy,zz;
float xa=0.,ya=0.,za=0.;
float xmax,xmin,ymax,ymin,zmax,zmin,xspread,yspread,zspread,spread;
float xmiddle,ymiddle,zmiddle;
float r1=0.,r2=0.,r3=0.;
float sr1=0., sr2=0., sr3=0.;
float cr1=0., cr2=0., cr3=0.;
float rd1=0,rd2=0,rd3=0;
int hertz=100, duration=10000;
float movex=0.,movey=0.,movez=300.;
float sx=0.,sy=0.;
float sxavg,syavg,sxstart,systart,sxseed,syseed;
float sxa=0., sya=0., sxb=0., syb=0., szb;
float pi=3.141592, d=1200.,a;
float angle,range,radius,xcenter,ycenter,xpt,ypt,xout,yout,xin,yin;
int   iloop, iloop2, iswapflag=1, ipoint, iface;
int   isection, j_level, icase, ibypass, jj;
int iplate_a,iplate_b,iplate_c;
int zin,zout,c;
char string[80],string_value[4],str_pointer;
int istring_start,ivalue,ivert,ix,iy,iz;
float tempiplate, tempzdepth;
int ispan, istep, ispanstep, idrawflag;
float dx1, dx2, dz1, dz2, dzstep, zlow, zhgh, zdepth, zlow_hold, zhgh_hold;
int    xlow, xhgh, xlow_hold, xhgh_hold, yhgh_hold;
struct { int xxx,yyy ; } points[5];

typedef struct { int x,y,z ; } point3d;
point3d triangle[3], point3d_one, point3d_two, point3d_three, point3d_temp;

int frame_buffer[640][10];          /* Frame Buffer For Pixel Color Values */
float   z_buffer[640][10];          /*     Z-Buffer For Pixel Depth Values */

int t1=0,t2=0,p1=0;
FILE *fp;
void keyboard(void);
void keyboard_input(void);
void calc_3d(void);
void rotation(void);
void vic_sort(void);
float maximum(float x,float y);
float minimum(float x,float y);
void polyfill_vic(void);

main()
{

	graphics_adapter=VGA; graphics_mode=VGAHI;
	initgraph(&graphics_adapter,&graphics_mode,"");
	cleardevice();

	setcolor(10);
	settextstyle(3,0,3);
	outtextxy( 50,  70,  "3D GRAPHICS PROCESSING DEMONSTRATION");
	setcolor(2);
	settextstyle(2,0,5);
	outtextxy( 50, 128,  "(c)  VLM  Engineering   1997");
	settextstyle(3,0,1);
	setcolor(13);
	outtextxy( 20, 200,  "1-  WIRE FRAME POLYGON DRAWING");
	setcolor(12);
	outtextxy( 20, 240,  "2-  FILLED POLYGON - FILLED AREA OBJECT DRAWING ");
	setcolor(11);
	outtextxy( 20, 280,  "3-  Z-BUFFER PROCESSING FOR VISIBLE SURFACE DETERMINATION");
	setcolor(12);
	outtextxy(175, 440,  "Press <Return> to Continue");
	getch();

	cleardevice();
						     /* NOW DRAW THE THING  */
	for(ipl=1; ipl<=7; ipl++) {                  /* read sequence of faces to be drawn */
	inumplate=ipl-1;                             /* step through each face           */
						     /* gather info for face to be drawn */
						     /* 0= A vertex for plate        */
						     /* 1= B vertex for plate        */
						     /* 2= C vertex for plate        */

/* TRIANGLE 1 */
if(ipl==1) {
point3d_one.x=200;  point3d_one.y=290; point3d_one.z=51;
triangle[0]=point3d_one;
point3d_two.x=160;  point3d_two.y=85;  point3d_two.z=25;
triangle[1]=point3d_two;
point3d_three.x=55;  point3d_three.y=217; point3d_three.z=77;
triangle[2]=point3d_three;
ipen=9;                               }

/* TRIANGLE 2 */
if(ipl==2) {
point3d_one.x=170;  point3d_one.y=340; point3d_one.z=41;
triangle[0]=point3d_one;
point3d_two.x=100;  point3d_two.y=110; point3d_two.z=35;
triangle[1]=point3d_two;
point3d_three.x=75;  point3d_three.y=217; point3d_three.z=86;
triangle[2]=point3d_three;
ipen=12;                             }

/* TRIANGLE 3 */
if(ipl==3) {
point3d_one.x=330;  point3d_one.y=190; point3d_one.z=145;
triangle[0]=point3d_one;
point3d_two.x=250;  point3d_two.y=60; point3d_two.z=135;
triangle[1]=point3d_two;
point3d_three.x=125;  point3d_three.y=152; point3d_three.z=18;
triangle[2]=point3d_three;
ipen=14;                             }

/* TRIANGLE 4 */
if(ipl==4) {
point3d_one.x=470;  point3d_one.y=190; point3d_one.z=325;
triangle[0]=point3d_one;
point3d_two.x=350;  point3d_two.y=100; point3d_two.z=30;
triangle[1]=point3d_two;
point3d_three.x=230;  point3d_three.y=210; point3d_three.z=120;
triangle[2]=point3d_three;
ipen=13;                             }

/* TRIANGLE 5 */
if(ipl==5) {
point3d_one.x=480;  point3d_one.y=135; point3d_one.z=760;
triangle[0]=point3d_one;
point3d_two.x=380;  point3d_two.y=70; point3d_two.z=5;
triangle[1]=point3d_two;
point3d_three.x=410;  point3d_three.y=295; point3d_three.z=82;
triangle[2]=point3d_three;
ipen=2;                             }

/* TRIANGLE 6 */
if(ipl==6) {
point3d_one.x=450;  point3d_one.y=232; point3d_one.z=132;
triangle[0]=point3d_one;
point3d_two.x=345;  point3d_two.y=225; point3d_two.z=615;
triangle[1]=point3d_two;
point3d_three.x=265;  point3d_three.y=335; point3d_three.z=130;
triangle[2]=point3d_three;
ipen=1;                             }

/* TRIANGLE 7 */
if(ipl==7) {
point3d_one.x=415;  point3d_one.y=360; point3d_one.z=500;
triangle[0]=point3d_one;
point3d_two.x=305;  point3d_two.y=260; point3d_two.z=170;
triangle[1]=point3d_two;
point3d_three.x=280;  point3d_three.y=420; point3d_three.z=280;
triangle[2]=point3d_three;
ipen=4;                             }

	if(ipen >=15) ipen=10;
	if(ipen <= 0) ipen=10;                       /* make sure pen is visible */
	setcolor(ipen);

	npoints=3;
	for(k=1; k<=npoints; k++) {                   /* visit every vertice which makes up plate to be drawn */
	npplate=npplate+1;                            /* count points which make up each plate                */
	point3d_temp=triangle[k-1];                   /* pick-up x,y,z for current vertice                    */
	sxb=point3d_temp.x;                           /* x-coord */
	syb=point3d_temp.y;                           /* y-coord */
	if(k==1) {sxsave=sxb;
		  sysave=syb;
		  sxlast=sxb;
		  sylast=syb; }
	moveto(sxlast,sylast);
	lineto(   sxb,   syb);
	sxlast=sxb;
	sylast=syb;
				   }                  /* close vertex loop for each face */
	moveto(sxlast,sylast);
	lineto(sxsave,sysave);
				   }                  /* close plate loop   */

	setcolor(11);
	settextstyle(3,0,1);
	outtextxy(125, 10,  "CASE 1-  WIRE FRAME OBJECT DRAWING");
        outtextxy( 80, 426, "Note: Cannot Tell Which Surfaces Are In Front Of Others");
	setcolor(12);
	outtextxy(175, 445, "Press <Return> to Continue");
	getch();

	cleardevice();
						     /* NOW DRAW THE THING  */
	for(ipl=1; ipl<=7; ipl++) {                  /* read sequence of faces to be drawn */
	inumplate=ipl-1;                             /* step through each face           */
						     /* gather info for face to be drawn */

/* TRIANGLE 1 */
if(ipl==1) {
point3d_one.x=200;  point3d_one.y=290; point3d_one.z=51;
triangle[0]=point3d_one;
point3d_two.x=160;  point3d_two.y=85;  point3d_two.z=25;
triangle[1]=point3d_two;
point3d_three.x=55;  point3d_three.y=217; point3d_three.z=77;
triangle[2]=point3d_three;
ipen=9;                               }

/* TRIANGLE 2 */
if(ipl==2) {
point3d_one.x=170;  point3d_one.y=340; point3d_one.z=41;
triangle[0]=point3d_one;
point3d_two.x=100;  point3d_two.y=110; point3d_two.z=35;
triangle[1]=point3d_two;
point3d_three.x=75;  point3d_three.y=217; point3d_three.z=86;
triangle[2]=point3d_three;
ipen=12;                             }

/* TRIANGLE 3 */
if(ipl==3) {
point3d_one.x=330;  point3d_one.y=190; point3d_one.z=145;
triangle[0]=point3d_one;
point3d_two.x=250;  point3d_two.y=60; point3d_two.z=135;
triangle[1]=point3d_two;
point3d_three.x=125;  point3d_three.y=152; point3d_three.z=18;
triangle[2]=point3d_three;
ipen=14;                             }

/* TRIANGLE 4 */
if(ipl==4) {
point3d_one.x=470;  point3d_one.y=190; point3d_one.z=325;
triangle[0]=point3d_one;
point3d_two.x=350;  point3d_two.y=100; point3d_two.z=30;
triangle[1]=point3d_two;
point3d_three.x=230;  point3d_three.y=210; point3d_three.z=120;
triangle[2]=point3d_three;
ipen=13;                             }

/* TRIANGLE 5 */
if(ipl==5) {
point3d_one.x=480;  point3d_one.y=135; point3d_one.z=760;
triangle[0]=point3d_one;
point3d_two.x=380;  point3d_two.y=70; point3d_two.z=5;
triangle[1]=point3d_two;
point3d_three.x=410;  point3d_three.y=295; point3d_three.z=82;
triangle[2]=point3d_three;
ipen=2;                             }

/* TRIANGLE 6 */
if(ipl==6) {
point3d_one.x=450;  point3d_one.y=232; point3d_one.z=132;
triangle[0]=point3d_one;
point3d_two.x=345;  point3d_two.y=225; point3d_two.z=615;
triangle[1]=point3d_two;
point3d_three.x=265;  point3d_three.y=335; point3d_three.z=130;
triangle[2]=point3d_three;
ipen=1;                             }

/* TRIANGLE 7 */
if(ipl==7) {
point3d_one.x=415;  point3d_one.y=360; point3d_one.z=500;
triangle[0]=point3d_one;
point3d_two.x=305;  point3d_two.y=260; point3d_two.z=170;
triangle[1]=point3d_two;
point3d_three.x=280;  point3d_three.y=420; point3d_three.z=280;
triangle[2]=point3d_three;
ipen=4;                             }
     
	if(ipen >=15) ipen=10;
	if(ipen <= 0) ipen=10;                       /* make sure pen is visible */
	setcolor(ipen);

	npoints=3;
	npplate=0;
	for(k=1; k<=npoints; k++) {                   /* visit every vertice which makes up plate to be drawn */
	npplate=npplate+1;                            /* count points which make up each plate                */
	point3d_temp=triangle[k-1];                   /* pick-up x,y,z for current vertice                    */
	sxb=point3d_temp.x;                           /* x-coord */
	syb=point3d_temp.y;                           /* y-coord */
	
	if(ipen >=15) ipen=10;
	if(ipen <= 0) ipen=10;                       /* make sure pen is visible */
	setcolor(ipen);

	points[npplate-1].xxx=sxb;
	points[npplate-1].yyy=syb;
	if(k==1) {
	sxa=sxb;
	sya=syb;
	sxstart=sxa;
	systart=sya;};
	sxa=sxb;                                      /* save last point x      */
	sya=syb;                       }              /* save last point y      */
	points[npplate].xxx=sxstart;                    /* return to start point to ensure closed polygon */
	points[npplate].yyy=systart;                    /* return to start point to ensure closed polygon */

	setfillstyle(1,ipen);                         /* set fill style to color polygon */

	setcolor(ipen);
	fillpoly( npplate, (int far *)points );       /* use polyfill command to draw filled polygon */
						      /* close vertex loop for each face */
				    }                 /* close plate loop   */

	setcolor(11);
	settextstyle(3,0,1);
	outtextxy( 30, 15,  "CASE 2-  FILLED POLYGON / FILLED AREA  OBJECT DRAWING");
        outtextxy(100, 426, "Note Improper Drawing of Non - Visible Surfaces");
	setcolor(12);
	outtextxy(175, 445, "Press <Return> to Continue");
	getch();

	cleardevice();
	setcolor(13);
	outtextxy(60, 30, "Z-Buffer Processing . . .");
	setcolor(10);
	outtextxy(60,100, "Depth Comparison On An Individual Pixel Basis      ");
	outtextxy(60,140, "To Determine The Portions Of Each Polygon          ");
	outtextxy(60,180, "Which Are Closest To The View Position             ");
	outtextxy(60,220, "For Visible Surface Determination                  ");
	setcolor(11);
	outtextxy(60,270, "This Requires Evaluation of Each Polygon On A      ");
	outtextxy(60,310, "Pixel Basis By Using Spans Across the Polygon      ");
	outtextxy(60,350, "While Computing the Plane Equation Across Each Face");
	outtextxy(60,390, "and Depth Value Storage for Each Pixel Drawn       ");
	setcolor(12);
	outtextxy(195,450,"Enter <Return> to Continue");
	getch();
	cleardevice();
	setcolor(10);
	outtextxy(60,140,"Z-Buffer Processing . . .");
	
	for(isection=1; isection<=48; isection++ ) {

	for(j=1; j<= 10; j++){                       /* Initialize frame_buffer and z_buffer */
	for(i=1; i<=640; i++){
	frame_buffer[i-1][j-1]=0;
	z_buffer    [i-1][j-1]=10000000.; } }

/* TRIANGLE 1 */
point3d_one.x=200;  point3d_one.y=290; point3d_one.z=51;
triangle[0]=point3d_one;
point3d_two.x=160;  point3d_two.y=85;  point3d_two.z=25;
triangle[1]=point3d_two;
point3d_three.x=55;  point3d_three.y=217; point3d_three.z=77;
triangle[2]=point3d_three;
ipen=9;
polyfill_vic();


/* TRIANGLE 2 */
point3d_one.x=170;  point3d_one.y=340; point3d_one.z=41;
triangle[0]=point3d_one;
point3d_two.x=100;  point3d_two.y=110; point3d_two.z=35;
triangle[1]=point3d_two;
point3d_three.x=75;  point3d_three.y=217; point3d_three.z=86;
triangle[2]=point3d_three;
ipen=12;
polyfill_vic();


/* TRIANGLE 3 */
point3d_one.x=330;  point3d_one.y=190; point3d_one.z=145;
triangle[0]=point3d_one;
point3d_two.x=250;  point3d_two.y=60; point3d_two.z=135;
triangle[1]=point3d_two;
point3d_three.x=125;  point3d_three.y=152; point3d_three.z=18;
triangle[2]=point3d_three;
ipen=14;
polyfill_vic();


/* TRIANGLE 4 */
point3d_one.x=470;  point3d_one.y=190; point3d_one.z=325;
triangle[0]=point3d_one;
point3d_two.x=350;  point3d_two.y=100; point3d_two.z=30;
triangle[1]=point3d_two;
point3d_three.x=230;  point3d_three.y=210; point3d_three.z=120;
triangle[2]=point3d_three;
ipen=13;
polyfill_vic();

/* TRIANGLE 5 */
point3d_one.x=480;  point3d_one.y=135; point3d_one.z=760;
triangle[0]=point3d_one;
point3d_two.x=380;  point3d_two.y=70; point3d_two.z=5;
triangle[1]=point3d_two;
point3d_three.x=410;  point3d_three.y=295; point3d_three.z=82;
triangle[2]=point3d_three;
ipen=2;
polyfill_vic();

/* TRIANGLE 6 */
point3d_one.x=450;  point3d_one.y=232; point3d_one.z=132;
triangle[0]=point3d_one;
point3d_two.x=345;  point3d_two.y=225; point3d_two.z=615;
triangle[1]=point3d_two;
point3d_three.x=265;  point3d_three.y=335; point3d_three.z=130;
triangle[2]=point3d_three;
ipen=1;
polyfill_vic();


/* TRIANGLE 7 */
point3d_one.x=415;  point3d_one.y=360; point3d_one.z=500;
triangle[0]=point3d_one;
point3d_two.x=305;  point3d_two.y=260; point3d_two.z=170;
triangle[1]=point3d_two;
point3d_three.x=280;  point3d_three.y=420; point3d_three.z=280;
triangle[2]=point3d_three;
ipen=4;
polyfill_vic();



	for(j=1; j<= 10; j++){                       /* Draw the frame_buffer */
	for(i=1; i<=640; i++){
	ipen=frame_buffer[i-1][j-1];
	j_level=(j-1) + (10*(isection-1));           /* Adjust the pixel location for this buffer section */
	putpixel(i-1, j_level, ipen);     } }        /* Draw the pixels from the frame_buffer */

					    }        /* close section loop */


	setcolor(3);
	settextstyle(5,0,2);
	outtextxy(100,  9,  "Z-BUFFER PROCESSING FOR VISIBLE SURFACE DETERMINATION");
	outtextxy(215, 20,  "   VGA  640 x 480");
	outtextxy(380,  465,"(c)   VLM  ENGINEERING  1997");
	getch();   /* hold screen */         }         /* close main() */

/*-------------------------------------------------------------
	SUBROUTINE: CALCULATE SIN, COS FACTORS
   Enter with r1,r2,r3 viewing angles for yaw, roll, pitch
   expressed in radians.  Returns sine and cosine factors.   */

void rotation(void){
sr1=sin(r1); sr2=sin(r2); sr3=sin(r3);
cr1=cos(r1); cr2=cos(r2); cr3=cos(r3); return;}



/*-------------------------------------------------------------
	SUBROUTINE: STANDARD 3D FORMULAS
    Enter with x,y,z cartesian world coordinates.  Returns sx,sy
    cartesian display coordinates.  Returns x,y,z cartesian view
    coordinates which includes rotation and translation effects.  */

void calc_3d(void){
x=(-1)*x; xa=cr1*x-sr1*z; za=sr1*x+cr1*z; x=cr2*xa+sr2*y;
ya=cr2*y-sr2*xa; z=cr3*za-sr3*ya; y=sr3*za+cr3*ya;
x=x+movex; y=y+movey; z=z+movez;
if(z==0.) z=.00001;
sx=d*x/z; sy=d*y/z; return;}

/*-------------------------------------------------------------
	SUBROUTINE: MAXIMUM
   Returns larger of two real numbers                          */

float maximum(float x, float y){
if(x >= y) {return x;};
if(x <= y) {return y;}; }

/*-------------------------------------------------------------
	SUBROUTINE: MINIMUM
   Returns smaller of two real numbers                         */

float minimum(float x, float y){
if(x <= y) {return x;};
if(x >= y) {return y;}; }

/*--------------------------------------------------------------
	SUBROUTINE:  KEYBOARD - SCREEN HOLD UNTIL ESC KEY       */
void keyboard(void){
union u_type{int a; char b[3];} keystroke;
int get_keystroke(void);
do keystroke.a=get_keystroke();
while (keystroke.b[0]!=110); }

int get_keystroke(void){
union REGS regs;regs.h.ah=0; return int86(0x16,&regs,&regs);}

/*--------------------------------------------------------------
	SUBROUTINE: DYNAMIC KEYBOARD INPUT
							       */
void keyboard_input(void){
union u_type{int a; char b[3];}keystroke; char inkey=0;

if(bioskey(1)==0) return;                   /* if no key, return      */
keystroke.a=bioskey(0);                     /* fetch ASCII code...    */
inkey=keystroke.b[0];                       /* ... and load code into variable */
switch (inkey) {                            /* make decision based upon ASCII value */
case 27:  exit(0);                          /* exit on <Esc> key      */
case 61:  movez=movez+20; return;           /* + key = move outwards  */
case 45:  movez=movez-20; return;           /* - key = move inwards   */
case 104: rd1=rd1-2;      return;           /* h key roll right       */
case 102: rd1=rd1+2;      return;           /* f key roll left        */
case 103: rd1=0;rd2=0;rd3=0; return;        /* g key return to nominal position */
case 116: rd2=rd2+2;      return;           /* t key pitch forward    */
case 98:  rd2=rd2-2;      return;           /* b key pitch back       */
case 118: rd3=rd3-2;      return;           /* v key yaw back         */
case 121: rd3=rd3+2;      return;           /* y key yaw forward      */

default: return;} }                         /* make routine bullet-proof */



/*--------------------------------------------------------------------------
	 SUBROUTINE POLYFILL_VIC
    Polygon Fill Routine With Depth Value Plane Equation        */

void polyfill_vic(void) {

/* setcolor(ipen); */                              /* Set Color of Face     */

point3d_one=triangle[0];
point3d_two=triangle[1];
point3d_three=triangle[2];

						   /* Get All Three Points Ordered By Y-Values */
if(point3d_two.y < point3d_one.y)
{ point3d_temp=point3d_one; point3d_one=point3d_two; point3d_two=point3d_temp;}        /* swap */
if(point3d_three.y < point3d_one.y)
{ point3d_temp=point3d_one; point3d_one=point3d_three; point3d_three=point3d_temp;}    /* swap */
if(point3d_three.y < point3d_two.y)
{ point3d_temp=point3d_two; point3d_two=point3d_three; point3d_three=point3d_temp;}    /* swap */
if(point3d_two.y < point3d_one.y)
{ point3d_temp=point3d_one; point3d_one=point3d_two; point3d_two=point3d_temp;}        /* swap */
if(point3d_three.y < point3d_one.y)
{ point3d_temp=point3d_one; point3d_one=point3d_three; point3d_three=point3d_temp;}    /* swap */
if(point3d_three.y < point3d_two.y)
{ point3d_temp=point3d_two; point3d_two=point3d_three; point3d_three=point3d_temp;}    /* swap */

/*  printf("Subroutine Polyfill_Vic \n");                                                 */
/*  printf("All Three Triangle Points Sorted By Y-Value \n");                             */
/*  printf("X1= %i  Y1= %i   Z1= %i \n",point3d_one.x,point3d_one.y,point3d_one.z);       */
/*  printf("X2= %i  Y2= %i   Z2= %i \n",point3d_two.x,point3d_two.y,point3d_two.z);       */
/*  printf("X3= %i  Y3= %i   Z3= %i \n",point3d_three.x,point3d_three.y,point3d_three.z); */
/*  getch();

/* All three points on a horizontal line */
if(point3d_one.y == point3d_two.y) {
if(point3d_one.y == point3d_three.y) {goto BYPASS ; } }
/* All three points on a vertical line */
if(point3d_one.x == point3d_two.x) {
if(point3d_one.x == point3d_three.x) {goto BYPASS ; } }

icase=0;                                                           /* Start with dx1 < dx2 */
ibypass=0;                                                         /* Used to flag when pt2.y == pt3.y */
if(point3d_one.y == point3d_two.y  ) {xhgh=point3d_one.x; zhgh=point3d_one.z;
				      xlow=point3d_two.x; zlow=point3d_two.z;
				      if(point3d_two.x > point3d_one.x) { icase=1;
				      xhgh=point3d_two.x; zhgh=point3d_two.z;
				      xlow=point3d_one.x; zlow=point3d_one.z;}     goto SPAN2to3; }
if(point3d_two.y == point3d_three.y) {ibypass=1;                                   goto SPAN1to2; }

SPAN1to2:
/* Compute Span Limits For Vertice 1 to 2        */
/* Compute Span Limit Increment Sizes Per Y Step */
/* Compute Delta-X on Left and Right   Compute Delta-Z on Left and Right */
dx1=(point3d_two.x - point3d_one.x)   / (1.*(point3d_two.y   - point3d_one.y));
dz1=(point3d_two.z - point3d_one.z)   / (1.*(point3d_two.y   - point3d_one.y));
dx2=(point3d_three.x - point3d_one.x) / (1.*(point3d_three.y - point3d_one.y));
dz2=(point3d_three.z - point3d_one.z) / (1.*(point3d_three.y - point3d_one.y));

if(dx2 < dx1) icase=1;                                             /* Flag cases with    dx2 < dx1  */

if(icase==1) {                                                     /* Reverse Limits for dx2 < dx1  */
dx1=(point3d_three.x - point3d_one.x)   / (1.*(point3d_three.y   - point3d_one.y));
dz1=(point3d_three.z - point3d_one.z)   / (1.*(point3d_three.y   - point3d_one.y));
dx2=(point3d_two.x - point3d_one.x)     / (1.*(point3d_two.y     - point3d_one.y));
dz2=(point3d_two.z - point3d_one.z)     / (1.*(point3d_two.y     - point3d_one.y));  }

istep=0;
for(jj=point3d_one.y; jj<=point3d_two.y; jj++) {                                 /* Step Down Face in Y */

xlow=point3d_one.x + istep*dx1;                                               /* Determine X Span Limits - Low and High */
xhgh=point3d_one.x + istep*dx2;
zlow=point3d_one.z + istep*dz1;                                               /* Determine Z Span Limits - Low and High */
zhgh=point3d_one.z + istep*dz2;
if(xhgh==xlow) { dzstep=0;}                                  /* Avoid divide by zero */
if(xhgh!=xlow) {dzstep=(zhgh - zlow) / (1.*(xhgh - xlow));}

istep=istep+1;

j_level=(jj-1) - (10*(isection-1));            /* Compute Adjusted Y-value for this section */
idrawflag=1;                                   /* Current Y-level within this section range */
if(j_level<0) idrawflag=0 ;                    /* Do not draw if out of bounds              */
if(j_level>9) idrawflag=0 ;                    /* Do not draw if out of bounds              */

ispanstep=0;
for(ispan=xlow; ispan<=xhgh; ispan ++) {
zdepth=zlow + ispanstep*dzstep;
ispanstep=ispanstep+1;
if(idrawflag==1) {
if(zdepth < z_buffer[ispan][j_level]) { frame_buffer[ispan][j_level]=ipen;           /* Compare Depth Z-Value At Each Pixel */
					    z_buffer[ispan][j_level]=zdepth;} } } }  /* To Determine If Should Draw New Color */

if(ibypass==1) goto BYPASS;                                                   /* Bypass For case when pt2.y == pt3.y */

/* Save Intermediate Points After Second Vertice */

SPAN2to3:
xhgh_hold=xhgh;
xlow_hold=xlow;
yhgh_hold=point3d_two.y;
zhgh_hold=zhgh;
zlow_hold=zlow;

/* Compute New Span Limits For Vertice 2 to 3    */
/* Compute Span Limit Increment Sizes Per Y Step */
/* Compute Delta-X on Left and Right   Compute Delta-Z on Left and Right */
dx1=(point3d_three.x - point3d_two.x)   / (1.*(point3d_three.y - point3d_two.y));
dz1=(point3d_three.z - point3d_two.z)   / (1.*(point3d_three.y - point3d_two.y));
dx2=(point3d_three.x - xhgh_hold)       / (1.*(point3d_three.y - point3d_two.y));
dz2=(point3d_three.z - zhgh_hold)       / (1.*(point3d_three.y - point3d_two.y));
if(icase==1) {                                                                     /* Reverse Limits for dx2 < dx1 */
dx1=(point3d_three.x - xlow_hold    )   / (1.*(point3d_three.y   - point3d_two.y));
dz1=(point3d_three.z - zlow_hold    )   / (1.*(point3d_three.y   - point3d_two.y));
dx2=(point3d_three.x - point3d_two.x)   / (1.*(point3d_three.y   - point3d_two.y));
dz2=(point3d_three.z - point3d_two.z)   / (1.*(point3d_three.y   - point3d_two.y));  }


istep=0;
for(jj=point3d_two.y; jj<=point3d_three.y; jj++) {                               /* Step Down Face in Y */

xlow=point3d_two.x + istep*dx1;                                               /* Determine X Span Limits - Low and High */
xhgh=xhgh_hold     + istep*dx2;
zlow=point3d_two.z + istep*dz1;                                               /* Determine Z Span Limits - Low and High */
zhgh=zhgh_hold     + istep*dz2;

if(icase==1) {                                                                /* Compute X Span Limits for dx2 < dx1 */
xlow=xlow_hold     + istep*dx1;
xhgh=point3d_two.x + istep*dx2;
zlow=zlow_hold     + istep*dz1;                                               /* Compute Z Span Limits for dx2 < dx1 */
zhgh=point3d_two.z + istep*dz2;   }

if(xhgh==xlow) { dzstep=0;}                                  /* Avoid divide by zero */
if(xhgh!=xlow) {dzstep=(zhgh - zlow) / (1.*(xhgh - xlow));}

istep=istep+1;

j_level=(jj-1) - (10*(isection-1));            /* Compute Adjusted Y-value for this section */
idrawflag=1;                                   /* Current Y-level within this section range */
if(j_level<0) idrawflag=0 ;                    /* Do not draw if out of bounds              */
if(j_level>9) idrawflag=0 ;                    /* Do not draw if out of bounds              */

ispanstep=0;
for(ispan=xlow; ispan<=xhgh; ispan ++) {
zdepth=zlow + ispanstep*dzstep;
ispanstep=ispanstep+1;
if(idrawflag==1) {
if(zdepth < z_buffer[ispan][j_level]) { frame_buffer[ispan][j_level]=ipen;           /* Compare Depth Z-Value At Each Pixel */
					    z_buffer[ispan][j_level]=zdepth;} } } }  /* To Determine If Should Draw New Color */

BYPASS:
return; }